jQuery(function($) {
    "use strict";

    var mapMarkers = [],
        componentForm = {
            locality: 'long_name',
            administrative_area_level_1: 'short_name',
            country: 'long_name'
        };

    var init_google_Map_s = function () {
        var mapDiv = document.getElementById('new-store-map-01'),
            map = new google.maps.Map(mapDiv, {
                zoom: 13,
                center: new google.maps.LatLng(33.733607, 73.097576)
            });

        // We add a DOM event here to show an alert if the DIV containing the
        // map is clicked.
        google.maps.event.addListener(map, 'click', function (event) {
            placeMarker(map, event.latLng);
        });
        var input = document.getElementById('google-auto-fill');
        var searchBox = new google.maps.places.SearchBox(input);

        map.addListener('bounds_changed', function () {
            searchBox.setBounds(map.getBounds());
        });

        searchBox.addListener('places_changed', function () {
            var places = searchBox.getPlaces();
            if (places.length == 0) {
                return;
            }
            var bounds = new google.maps.LatLngBounds();
            places.forEach(function (place) {
                if (!place.geometry) {
                    console.log("Returned place contains no geometry");
                    return;
                }
                for (var component in componentForm) {
                    document.getElementById(component).value = '';
                    document.getElementById(component).disabled = false;
                }
                if (place.address_components) {
                    for (var i = 0; i < place.address_components.length; i++) {
                        var addressType = place.address_components[i].types[0];
                        if (componentForm[addressType]) {
                            var val = place.address_components[i][componentForm[addressType]];
                            document.getElementById(addressType).value = val;
                            $("#" + addressType).focusin().focusout();
                        }
                    }
                }

                /*=====*/
                if (place.geometry.viewport) {
                    bounds.union(place.geometry.viewport);
                } else {
                    bounds.extend(place.geometry.location);
                }
            });
            map.fitBounds(bounds);
        });
    };

    function placeMarker(map, location) {
        if (mapMarkers.length) {
            mapMarkers.forEach(function (marker) {
                marker.setMap(null);
            });
            mapMarkers = [];
        }
        var marker = new google.maps.Marker({
            position: location,
            map: map
        });
        var storeLat = marker.getPosition().lat(),
            storeLong = marker.getPosition().lng();
        $("#storeLat").val(storeLat);
        $("#storeLng").val(storeLong);
        mapMarkers.push(marker);
    }

    if ($("#new-store-map-01").length) init_google_Map_s();

});